#!/bin/sh
#
# Install script for OpenBeOS Translation Kit BETA

answer=`alert "Install OpenBeOS Translation Kit BETA?" "Yes" "No"`
if [ $answer == "No" ]; then
	alert "Installation cancelled" "OK"
	exit
fi

# figure out what directory this script is running from
curdir=`dirname "$0"`
if [ "$curdir" == "." ]; then
	curdir=`pwd`
fi

# Make backup directories
mkdir /boot/home/TKBackup{,/translators,/libs,/apps}

# Backup BeOS translators and move them out of the way
for tran in BMP JPEG PNG PPM STXT TGA TIFF
do
	source="/system/add-ons/Translators/${tran}Translator"
	if [ -e "$source" ]; then
		copyattr -d  "$source" /boot/home/TKBackup/translators
		rm "$source"
	fi
done

# Just to be safe, backup BeOS libtranslation and ShowImage, even though
# they aren't changed by this install
copyattr -d /system/lib/libtranslation.so /boot/home/TKBackup/libs
copyattr -d /boot/beos/apps/ShowImage /boot/home/TKBackup/apps

# Install OpenBeOS Translation Kit files
copyattr -d "$curdir"/translators/* /boot/home/config/add-ons/Translators
copyattr -d "$curdir"/libs/* /boot/home/config/lib
copyattr -d "$curdir"/apps/* /boot/apps

# Make link to OBOS ShowImage in Applications menu
rm "/boot/home/config/be/Applications/OBOS ShowImage"
ln -s /boot/apps/OpenShowImage "/boot/home/config/be/Applications/OBOS ShowImage"

alert "Completed OpenBeOS Translation Kit BETA install." "OK"
